function [X_m, E_m] = Markowitz(R, V, TradeOff)
N=size(V,1);
a=R'*(V\R);
b=ones(1,N)*(V\R);
c=ones(1,N)*(V\ones(N,1));
E_m = b/c + (a*c-b*b)/(c*sqrt(TradeOff*TradeOff*c-a*c+b*b));
X_m = (V\(a*ones(N,1)-b*R)+ E_m*(V\(c*R-b*ones(N,1))))/(a*c-b*b);


%Alte Version
%V_1=inv(V);
%a=R'*V_1*R;
%b=ones(1,N)*V_1*R;
%c=ones(1,N)*V_1*ones(N,1);
%E_m = b/c + (a*c-b*b)/(c*sqrt(TradeOff*TradeOff*c-a*c+b*b));
%X_m = (V_1*(a*ones(N,1)-b*R)+ E_m*V_1*(c*R-b*ones(N,1)))/(a*c-b*b);