%% Daten lesen nur beim ersten Durchlauf notwendig
% Daten = xlsread('Input_30DAX.xlsx','A3:AE1273');

%% Daten einschrnken
%Spalten der DAX 30: A:AE  (XLSX-Tabelle)
%Zeile 1: Lauf-Nr. der Aktien, Zeile 2: Namen der Aktien, ab 3.Zeile Daten
%2004: A3:AE259      (In der Matrix "Daten" 1:257)
%2005: A260:AE515    (In der Matrix "Daten" 258:513)
%2006: A516:AE770    (In der Matrix "Daten" 514:768)
%2007: A771:AE1021   (In der Matrix "Daten" 769:1019)
%2008: A1022:AE1273  (In der Matrix "Daten" 1020:1271)
%2009: A1274:AE1525  (In der Matrix "Daten" 1272:1523)
Input = Daten(1020:1271,:);

%% Entweder Q und c aus den Daten berechnen oder beides laden 
% 1. Berechnung
    % Fehler=0.01; % Fehlertoleranz
    % [Q , c] = MVE(Input', Fehler); % Berechnung von Q und c
    
% 2. Laden
    load 'Q_R_08-08_0,01';
    load 'c_R_08-08_0,01';

%% grafische Ausgabe
plot(sort(diag((Input'-c*ones(1,size(Input,1)))' * Q * (Input'-c*ones(1,size(Input,1))))))
xlabel('Datenpunkte')
ylabel('quadratische Q-Norm')
title('quadratische Q-Norm zum Zentrum des MVEs(Daten: 2008)')
