%% Erluterungen
% Diese Prozedur erstellt Matrix und erfasst die Aufteilungen fr 
% verschiedenen Zeitrumen zum einer festem TradeOff.

%% Nachfolgend sind drei Varianten:
% 1. Strukturmatrix und Zentrum werden neu berechnet, je nachdem
     %welche Daten als Vorinfo eingelesen werden
% vorhandene Strukturmatrix und Zentrum werden geladen
% 2. Q & c bereits aus Renditen als Vorinformation berechnet
% 3. Q & c bereits aus Schwerpunkten als Vorinformation berechnet
Variante = 3;

%% Trade Off spezifizieren
TradeOff =(7*sqrt(7)-1)/9; 
% = (7*sqrt(7)-1)/9 = 1,9467      %s(a)=(7-6a), w(a)=1, q=1, 
% = (7*sqrt(7)-1)/18 = 0,9733     %s(a)=(7-6a), w(a)=1, q=0,75
% = 2/3 = 0,66                    %s(a)=1-a^2, w(a)=2a, q=1


%% Fuzzy Aufteilung (neu Berechnung von Q & c)
% % Matrizen fr die Ausgabe der Ergebnisse
% % Fr Fuzzy, Anzahle der Aktien + 4 Kennzahlen je Aufteilung
if Variante == 1
    Ausgabe_f=zeros(34, 15);  %15 ist die Anzahl der verschiedenen Zeitrume
    Fehler=1/100;
    
    % Daten einlesen
    Daten = xlsread('Input_30DAX.xlsx','A3:AE1273');
    % Daten einschrnken
    %Spalten der DAX 30: A:AE  der XLSX-Tabelle (Matrix Daten)
    %Zeile 1: Lauf-Nr. der Aktien, Zeile 2: Namen der Aktien, ab 3.Zeile Daten
    %2004: A3:AE259      (In der Matrix "Daten" 1:257) 
    %2005: A260:AE515    (In der Matrix "Daten" 258:513)
    %2006: A516:AE770    (In der Matrix "Daten" 514:768)
    %2007: A771:AE1021   (In der Matrix "Daten" 769:1019)
    %2008: A1022:AE1273  (In der Matrix "Daten" 1020:1271)
    %2009: A1274:AE1525  (In der Matrix "Daten" 1272:1523)
    %Entsprechende Zeilenreferenz in der Matrix Daten:
    A_04=1;    E_04=257;
    A_05=258;  E_05=513;
    A_06=514;  E_06=768;
    A_07=769;  E_07=1019;
    A_08=1020; E_08=1271;
    
    i=1;
% 1. Zeitraum 2004
    Input = Daten(A_04:E_04,:);  [Q , c] = MVE(Input', Fehler); 
    Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 2. Zeitraum 2005
    Input = Daten(A_05:E_05,:);  [Q , c] = MVE(Input', Fehler); 
    Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 3. Zeitraum 2006
    Input = Daten(A_06:E_06,:);  [Q , c] = MVE(Input', Fehler); 
    Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1; 
% 4. Zeitraum 2007
    Input = Daten(A_07:E_07,:);  [Q , c] = MVE(Input', Fehler); 
    Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 5. Zeitraum 2008
    Input = Daten(A_08:E_08,:);  [Q , c] = MVE(Input', Fehler); 
    Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 6. Zeitraum 2004-2005
    Input = Daten(A_04:E_05,:);  [Q , c] = MVE(Input', Fehler); 
    Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 7. Zeitraum 2005-2006
    Input = Daten(A_05:E_06,:);  [Q , c] = MVE(Input', Fehler); 
    Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 8. Zeitraum 2006-2007
    Input = Daten(A_06:E_07,:);  [Q , c] = MVE(Input', Fehler); 
    Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 9. Zeitraum 2007-2008
    Input = Daten(A_07:E_08,:);  [Q , c] = MVE(Input', Fehler); 
    Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 10. Zeitraum 2004-2006
    Input = Daten(A_04:E_06,:);  [Q , c] = MVE(Input', Fehler); 
    Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 11. Zeitraum 2005-2007
    Input = Daten(A_05:E_07,:);  [Q , c] = MVE(Input', Fehler); 
    Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 12. Zeitraum 2006-2008
    Input = Daten(A_06:E_08,:);  [Q , c] = MVE(Input', Fehler); 
    Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 13. Zeitraum 2004-2007
    Input = Daten(A_04:E_07,:);  [Q , c] = MVE(Input', Fehler); 
    Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 14. Zeitraum 2005-2008
    Input = Daten(A_05:E_08,:);  [Q , c] = MVE(Input', Fehler); 
    Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 15. Zeitraum 2004-2008
    Input = Daten(A_04:E_08,:);  [Q , c] = MVE(Input', Fehler); 
    Ausgabe_f(:,i) = f_write(TradeOff, Q, c); 
end

%% Fuzzy Aufteilung (vorh. Q udn c werden geladen)
% Rendite(R) als Vorinfo 
if Variante == 2
    Ausgabe_f=zeros(34, 15);  %15 ist die Anzahl der Zeitrume
    i=1;
% 1. Zeitraum 2004
     load 'Q_R_04-04_0,01'; load 'c_R_04-04_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 2. Zeitraum 2005
     load 'Q_R_05-05_0,01'; load 'c_R_05-05_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 3. Zeitraum 2006
     load 'Q_R_06-06_0,01'; load 'c_R_06-06_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1; 
% 4. Zeitraum 2007
     load 'Q_R_07-07_0,01'; load 'c_R_07-07_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 5. Zeitraum 2008
     load 'Q_R_08-08_0,01'; load 'c_R_08-08_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 6. Zeitraum 2004-2005
     load 'Q_R_04-05_0,01'; load 'c_R_04-05_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 7. Zeitraum 2005-2006
     load 'Q_R_05-06_0,01'; load 'c_R_05-06_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 8. Zeitraum 2006-2007
     load 'Q_R_06-07_0,01'; load 'c_R_06-07_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 9. Zeitraum 2007-2008
     load 'Q_R_07-08_0,01'; load 'c_R_07-08_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 10. Zeitraum 2004-2006
     load 'Q_R_04-06_0,01'; load 'c_R_04-06_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 11. Zeitraum 2005-2007
     load 'Q_R_05-07_0,01'; load 'c_R_05-07_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 12. Zeitraum 2006-2008
     load 'Q_R_06-08_0,01'; load 'c_R_06-08_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 13. Zeitraum 2004-2007
     load 'Q_R_04-07_0,01'; load 'c_R_04-07_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 14. Zeitraum 2005-2008
     load 'Q_R_05-08_0,01'; load 'c_R_05-08_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 15. Zeitraum 2004-2008
     load 'Q_R_04-08_0,01'; load 'c_R_04-08_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c); 
end 

%% Fuzzy Aufteilung (vorh. Q udn c werden geladen)
% Schwerpunkte als Vorinfo 
if Variante == 3
    Ausgabe_f=zeros(34, 15);  %15 ist die Anzahl der Zeitrume
    i=1;
% 1. Zeitraum 2004
     load 'Q_c_04-04_0,01'; load 'c_c_04-04_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 2. Zeitraum 2005
     load 'Q_c_05-05_0,01'; load 'c_c_05-05_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 3. Zeitraum 2006
     load 'Q_c_06-06_0,01'; load 'c_c_06-06_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1; 
% 4. Zeitraum 2007
     load 'Q_c_07-07_0,01'; load 'c_c_07-07_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 5. Zeitraum 2008
     load 'Q_c_08-08_0,01'; load 'c_c_08-08_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 6. Zeitraum 2004-2005
     load 'Q_c_04-05_0,01'; load 'c_c_04-05_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 7. Zeitraum 2005-2006
     load 'Q_c_05-06_0,01'; load 'c_c_05-06_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 8. Zeitraum 2006-2007
     load 'Q_c_06-07_0,01'; load 'c_c_06-07_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 9. Zeitraum 2007-2008
     load 'Q_c_07-08_0,01'; load 'c_c_07-08_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 10. Zeitraum 2004-2006
     load 'Q_c_04-06_0,01'; load 'c_c_04-06_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 11. Zeitraum 2005-2007
     load 'Q_c_05-07_0,01'; load 'c_c_05-07_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 12. Zeitraum 2006-2008
     load 'Q_c_06-08_0,01'; load 'c_c_06-08_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 13. Zeitraum 2004-2007
     load 'Q_c_04-07_0,01'; load 'c_c_04-07_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 14. Zeitraum 2005-2008
     load 'Q_c_05-08_0,01'; load 'c_c_05-08_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c); i=i+1;
% 15. Zeitraum 2004-2008
     load 'Q_c_04-08_0,01'; load 'c_c_04-08_0,01';
     Ausgabe_f(:,i) = f_write(TradeOff, Q, c);
end