%% Erluterungen
% Diese Prozedur erstellt Matrix und erfasst
% die Aufteilungen fr verschiedene Zeitperioden
% zum einer festem TradeOff.
TradeOff = (7*sqrt(7)-1)/9; %(7*sqrt(7)-1)/9;  %1,9467      %s(a)=(7-6a), w(a)=1, q=1, 
%TradeOff_2 = (7*sqrt(7)-1)/18;  %0,9733      %s(a)=(7-6a), w(a)=1, q=0,75
%TradeOff_3 = 2/3;   %s(a)=1-a^2, w(a)=2a, q=1

%% Daten lesen nur beim ersten Durchlauf!
Daten = xlsread('Input_30DAX.xlsx','A3:AE1273');

%% Matrizen fr die Ausgabe der Ergebnisse
% Fr Markowitz, Anzahle der Aktien + 3 Kennzahlen je Aufteilung
Ausgabe_m=zeros(size(Daten,2)+3, 15);  %15 ist die Anzahl der Zeitperioden

%% Daten einschrnken
%Spalten der DAX 30: A:AE  der XLSX-Tabelle (Matrix Daten)
%Zeile 1: Lauf-Nr. der Aktien, Zeile 2: Namen der Aktien, ab 3.Zeile Daten
%2004: A3:AE259      (In der Matrix "Daten" 1:257) 
%2005: A260:AE515    (In der Matrix "Daten" 258:513)
%2006: A516:AE770    (In der Matrix "Daten" 514:768)
%2007: A771:AE1021   (In der Matrix "Daten" 769:1019)
%2008: A1022:AE1273  (In der Matrix "Daten" 1020:1271)
%2009: A1274:AE1525  (In der Matrix "Daten" 1272:1523)
%Entsprechende Zeilenreferenz in der Matrix Daten:
A_04=1; E_04=257;
A_05=258; E_05=513;
A_06=514; E_06=768;
A_07=769; E_07=1019;
A_08=1020; E_08=1271;


%% Markowitz
clc;
i=1;
% 1. Zeitperiode 2004
 Input = Daten(A_04:E_04,:);
 Ausgabe_m(:,i) = m_write(Input,TradeOff); i=i+1;
% 2. Zeitperiode 2005
 Input = Daten(A_05:E_05,:);
 Ausgabe_m(:,i) = m_write(Input,TradeOff); i=i+1;
% 3. Zeitperiode 2006
 Input = Daten(A_06:E_06,:);
 Ausgabe_m(:,i) = m_write(Input,TradeOff); i=i+1; 
% 4. Zeitperiode 2007
 Input = Daten(A_07:E_07,:);
 Ausgabe_m(:,i) = m_write(Input,TradeOff); i=i+1;
% 5. Zeitperiode 2008
 Input = Daten(A_08:E_08,:);
 Ausgabe_m(:,i) = m_write(Input,TradeOff); i=i+1;
% 6. Zeitperiode 2004-2005
 Input = Daten(A_04:E_05,:);
 Ausgabe_m(:,i) = m_write(Input,TradeOff); i=i+1;
% 7. Zeitperiode 2005-2006
 Input = Daten(A_05:E_06,:);
 Ausgabe_m(:,i) = m_write(Input,TradeOff); i=i+1;
% 8. Zeitperiode 2006-2007
 Input = Daten(A_06:E_07,:);
 Ausgabe_m(:,i) = m_write(Input,TradeOff); i=i+1;
% 9. Zeitperiode 2007-2008
 Input = Daten(A_07:E_08,:);
 Ausgabe_m(:,i) = m_write(Input,TradeOff); i=i+1;
% 10. Zeitperiode 2004-2006
 Input = Daten(A_04:E_06,:);
 Ausgabe_m(:,i) = m_write(Input,TradeOff); i=i+1;
% 11. Zeitperiode 2005-2007
 Input = Daten(A_05:E_07,:);
 Ausgabe_m(:,i) = m_write(Input,TradeOff); i=i+1;
% 12. Zeitperiode 2006-2008
 Input = Daten(A_06:E_08,:);
 Ausgabe_m(:,i) = m_write(Input,TradeOff); i=i+1;
% 13. Zeitperiode 2004-2007
 Input = Daten(A_04:E_07,:);
 Ausgabe_m(:,i) = m_write(Input,TradeOff); i=i+1;
% 14. Zeitperiode 2005-2008
 Input = Daten(A_05:E_08,:);
 Ausgabe_m(:,i) = m_write(Input,TradeOff); i=i+1;
% 15. Zeitperiode 2004-2008
 Input = Daten(A_04:E_08,:);
 Ausgabe_m(:,i) = m_write(Input,TradeOff); i=i+1;